
{% extends 'base/base.html' %}

{% block page_content %}
    <form method="post" id="frmCompras">
        {% csrf_token %}
        <div class="col-xl-12 col-md-12 mb-12">
            
            {% if encabezado %}
                <div class="card border-left-warning shadow h-100 py-2">
            {% else %}
                <div class="card border-left-success shadow h-100 py-2">
            {% endif %}
                <div class="card-body">
                    <div class="row no-gutters align-items-center">
                        <div class="col mr-2">
                            <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                {% if encabezado %} Editar {% else %} Nueva {% endif %} Compra  
                            </div>
                        
                            <div class="dropdown-divider"></div>
                            <div class="row">
                                <!-- Inicio Izquierda -->
                                <div class="col-6">
                                    <!-- Inicio Encabezado -->
                                    <div class="form-group row">
                                        <label for="staticEmail" class="col-sm-3 col-form-label">Proveedor:</label>
                                        <div class="col-sm-12">
                                            {{ form_enc.proveedor }}
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="col-6">
                                            <div class="form-group">
                                                <label for="id_fecha_compra">Fecha Compra:</label>
                                                {{ form_enc.fecha_compra }}
                                            </div>
                                            <div class="form-group">
                                                <label for="id_descripcion">Descripción:</label>
                                                {{ form_enc.observacion }}
                                            </div>
                                        </div>

                                        <div class="col-6">
                                            <div class="form-group">
                                                <label for="id_no_factura">No. Factura:</label>
                                                {{ form_enc.no_factura }}
                                            </div>
                                            <div class="form-group">
                                                <label for="id_fecha_factura">Fecha Factura:</label>
                                                {{ form_enc.fecha_factura }}
                                            </div>
                                            <div class="row">
                                                <div class="col">
                                                    <label for="sub_total">Sub Total:</label>
                                                </div>
                                                <div class="col">
                                                    {{ form_enc.sub_total }}
                                                </div>
                                            </div>

                                            <div class="row">
                                                <div class="col">
                                                    <label for="descuento">Descuento:</label>
                                                </div>
                                                <div class="col">
                                                    {{ form_enc.descuento }}
                                                </div>
                                            </div>

                                            <div class="row">
                                                <div class="col">
                                                    <label for="total">Total:</label>
                                                </div>
                                                <div class="col">
                                                    {{ form_enc.total }}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <!-- Fin Encabezado -->
                                </div>
                                <!-- Fin Izquierda -->
                                <!-- Inicio Derecha -->
                                <div class="col-6">
                                    <div class="row">
                                        <div class="col">
                                            <table class="table table-striped table-hover dt-responsive nowrap tbl-productos" style="width: 100%;">
                                                <thead>
                                                    <th>Id</th>
                                                    <th class="all">Descripción</th>
                                                    <th class="all">Acciones</th>
                                                </thead>
                                                <tbody>
                                                    
                                                    {% for item in productos %}
                                                        <tr>
                                                            <td>{{ item.id }} </td>
                                                            <td>{{ item.descripcion }}</td>
                                                            <td>
                                                                <button type="button" class="btn btn-warning btn-circle" onclick="selectProducto({{ item.id }}, '{{ item.descripcion }}' )"><i class="far fa-hand-pointer"></i></button>
                                                            </td>
                                                        </tr>
                                                    {% endfor %}  
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <label for="id_id_producto" class="col-sm-3 col-form-label">Producto</label>
                                        <div class="col-sm-2">
                                            <input type="text" readonly class="form-control-plaintext" name="id_id_producto" id="id_id_producto" value="" required>
                                        </div>
                                        <div class="col-sm-6">
                                            <input type="text" readonly class="form-control-plaintext" id="id_descripcion_producto" value="" required>
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label for="id_cantidad_detalle" class="col-sm-2 col-form-label">Cant.:</label>
                                        <div class="col-sm-2">
                                            <input type="number" class="form-control" name="id_cantidad_detalle" id="id_cantidad_detalle" value="00" required>
                                        </div>

                                        <label for="id_precio_detalle" class="col-sm-2 col-form-label">Precio:</label>
                                        <div class="col-sm-2">
                                            <input type="number" class="form-control" name="id_precio_detalle" id="id_precio_detalle" value="00" required>
                                        </div>

                                        <label for="id_descuento_detalle" class="col-sm-2 col-form-label">Desc.:</label>
                                        <div class="col-sm-2">
                                            <input type="number" class="form-control" name="id_descuento_detalle" id="id_descuento_detalle" value="00">
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label for="id_sub_total_detalle" class="col-sm-2 col-form-label">S. Total:</label>
                                        <div class="col-sm-4">
                                            <input type="text" readonly class="form-control-plaintext" name="id_sub_total_detalle" id="id_sub_total_detalle" value="00">
                                        </div>

                                        <label for="id_total_detalle" class="col-sm-2 col-form-label">Total:</label>
                                        <div class="col-sm-3">
                                            <input type="text" readonly class="form-control-plaintext col-sm-10" name="id_total_detalle" id="id_total_detalle" value="00">
                                        </div>

                                        <div class="col-sm-1">
                                            <button type="button" class="btn btn-sm col-sm-2" onclick="clear_Detail();"><i class="fa fa-minus-circle" aria-hidden="true"></i></button>
                                        </div>
                                    </div>

                                    <!-- Botones -->
                                    <div class="dropdown-divider"></div>
                                    <div class="row">
                                        <div class="col">
                                            <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span>Guardar</button>
                                            <a href="{% url 'cmp:compras_list' %}" class="btn btn-success"><i class="far fa-hand-point-left"></i>Cancelar</a>
                                        </div>
                                    </div>
                                    <!-- Fin Botones -->
                                </div>
                                <!-- Fin Derecha -->
                            </div>
                        </div>
                    </div>
                    <!-- Inicio Detalle -->
                    <div class="dropdown-divider"></div>
                    <div class="row">
                        <div class="col">
                            <table class="table table-striped table-hover dt-responsive nowrap" style="width:100%">
                                <thead>
                                    <th>Producto</th>
                                    <th>Cantidad</th>
                                    <th>Precio</th>
                                    <th>Sub Total</th>
                                    <th>Desc.</th>
                                    <th>Total</th>
                                </thead>
                                <tbody>
                                    
                                    {% for item in detalle %}
                                    <tr>
                                        <td>{{ item.producto }}</td>
                                        <td>{{ item.cantidad }}</td>
                                        <td>{{ item.precio_prv }}</td>
                                        <td>{{ item.sub_total }}</td>
                                        <td>{{ item.descuento }}</td>
                                        <td>{{ item.total }}</td>
                                        <td>
                                            <button class="btn btn-danger btn-circle" onclick="return abrir_modal('{% url 'cmp:compras_del' encabezado.pk item.id %}')"><i class="fas fa-trash-alt"></i></button>
                                        </td>
                                    </tr>
                                    {% endfor %}
                                        
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
        </div>
    </form>
{% endblock page_content %}

{% block js_page %}
    <script>
        // llamamos el dataTables jQuery plugin
        $(function() {
            $('.table').DataTable({
                "pageLength": 2,
                "language": {
                    "processing": "Procesando...",
                    "lengthMenu": "Mostrar _MENU_ registros",
                    "zeroRecords": "No se encontraron resultados",
                    "emptyTable": "Ningún dato disponible en esta tabla",
                    "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                    "infoFiltered": "(filtrado de un total de _MAX_ registros)",
                    "search": "Buscar:",
                    "infoThousands": ",",
                    "loadingRecords": "Cargando...",
                    "paginate": {
                        "first": "Primero",
                        "last": "Último",
                        "next": "Siguiente",
                        "previous": "Anterior"
                    },
                    "aria": {
                        "sortAscending": ": Activar para ordenar la columna de manera ascendente",
                        "sortDescending": ": Activar para ordenar la columna de manera descendente"
                    }
                }
            });

            $('#id_cantidad_detalle, #id_precio_detalle, #id_descuento_detalle').change(function(){
                calcular_detalle();
            });

            /* Validar Envio de Detalle */
            $("#frmCompras").submit(function(e){
                if($('#id_total_detalle').val()==0 || $('#id_id_producto').val()==0){
                    e.preventDefault();
                    //alert("no ha agregado producto o esta sin cantidades");
                    $.alert({
                        type: 'red',
                        title: '',
                        content: 'No ha agregado producto o esta sin cantidades'                     
                    })
                }
            });
            /* Fin Validar Envio de Detalle */

        });

        $(function(){
            $("#id_fecha_compra, #id_fecha_factura").datetimepicker({
                timepicker:false,
                format:'Y-m-d'
            });
        });

        function selectProducto(id, descripcion){
            $('#id_cantidad_detalle').val(0);
            $('#id_precio_detalle').val(0);
            $('#id_descuento_detalle').val(0);

            $('#id_sub_total_detalle').val(0);
            $('#id_total_detalle').val(0);

            $('#id_id_producto').val(+id);
            $('#id_descripcion_producto').val(descripcion);
            $('#id_cantidad_detalle').focus();
            $('#id_cantidad_detalle').select();

            $('.table').DataTable().search('').draw();
        }

        function calcular_detalle(){
            var cantidad, precio, desc, sub_total, total;

            cantidad = $('#id_cantidad_detalle').val();
            cantidad = cantidad === "" ? 0 : +cantidad;
            cantidad = cantidad < 0 ? 0: cantidad;

            precio = $('#id_precio_detalle').val();
            precio = precio === "" ? 0 : +precio;
            precio = precio < 0 ? 0 : precio;

            desc = $('#id_descuento_detalle').val();
            desc = desc === "" ? 0 : +desc;
            desc = desc < 0 ? 0 : desc;

            desc = desc>(cantidad *precio) ? 0 : desc;

            sub_total = cantidad * precio;
            total = sub_total - desc;

            //rellenamos los campos del formulario con los valores calculados
            $('#id_cantidad_detalle').val(cantidad);
            $('#id_precio_detalle').val(precio);
            $('#id_descuento_detalle').val(desc);

            $('#id_sub_total_detalle').val(sub_total);
            $('#id_total_detalle').val(total);
        }

        function clear_Detail(){
            // función que limpia los campos
            $('#id_cantidad_detalle').val(0);
            $('#id_precio_detalle').val(0);
            $('#id_descuento_detalle').val(0);

            $('#id_sub_total_detalle').val(0);
            $('#id_total_detalle').val(0);

            $('#id_id_producto').val('');
            $('#id_descripcion_producto').val('');

            $('.table').DataTable().search('').draw();
            $("#id_proveedor").focus();
        }

        $("#id_proveedor").focus();

    </script>
   
{% endblock js_page %}
